/**
 * 
 */
package stx.libjava.tools.compiler;

import java.io.ByteArrayInputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.URI;
import javax.tools.SimpleJavaFileObject;


/**
 * @author Jan Vrany
 *
 */
public class JavaSourceFile extends SimpleJavaFileObject {
	private String src;   
	
	public JavaSourceFile(String name, String src) {       
		super(URI.create("file:///" + name + ".java"), Kind.SOURCE);       
		this.src = src;  
	}   
	public CharSequence getCharContent(boolean ignoreEncodingErrors) {       
		return src;   
	}   
	public OutputStream openOutputStream() {       
		throw new IllegalStateException();   
	}   
	public InputStream openInputStream() {       
		return new ByteArrayInputStream(src.getBytes());   
	}
}
